"use strict";

{
	C3.Plugins.aaXe_Chance.Acts =
	{
		SetSeed(num)
		{
			if(this._useSeed){
				this._seed = num;
				this.chance = new Chance(this._seed); 
			}
		},
		
		RollDice(dice, sides, tag)
		{
			if(tag === ""){
				tag = "default"
			}

			//does tag exist?
			if(this._diceRoll.hasOwnProperty(tag)){
				this._diceRoll[tag].sum = 0;
				this._diceRoll[tag].roll = this.chance.rpg(dice+'d'+sides);
			//if not push new tag	
			} else{
				this._diceRoll[tag] = {
					sum : 0,
					roll : this.chance.rpg(dice+'d'+sides)
				}
			}	

			//cache dice sum
			this._diceRoll[tag].roll.forEach((ele) => {
				this._diceRoll[tag].sum += ele;
			});	

			//set last dice roll
			this._lastDiceRoll = this._diceRoll[tag].roll;
			this._lastDiceSum = this._diceRoll[tag].sum;
			this._lastDiceTag = tag;

			//execute trigger
			this.Trigger(C3.Plugins.aaXe_Chance.Cnds.OnRoll);
			this.Trigger(C3.Plugins.aaXe_Chance.Cnds.OnRollContains);
		},

		ShuffleArray(obj)
		{
			var instance = obj.GetInstances()[0].GetSdkInstance();
			var temp = [];

			//todo: replace with public method when released
			//var width = instance.GetWidth();
			//var width = instance._cx;

			var newArr = this.chance.shuffle(instance._arr);
			instance._arr = newArr;

			//working implementation using temp arrays
			// for(var i = 0; i<width; i++) {
			// 	temp.push(instance.At(i,0,0));
			// }
			// var temp = this.chance.shuffle(temp);
			// for(var i = 0; i<width; i++) {
			// 	instance.Set(i,0,0,temp[i]);
			// }
		}
	};
}