"use strict";

{
	C3.Plugins.aaXe_Chance.Exps =
	{
		GetSeed()
		{
			return this.chance.mt.seed;
		},

		GetCharacterPool(pool)
		{
			if(pool === ""){
				return this.chance.character();
			}

			return this.chance.character({pool:pool});
		},

		GetCharacter()
		{
			return this.chance.character();
		},

		GetCharacterLower()
		{
			return this.chance.character({pool:'abcdefghijklmnopqrstuvwxyz'});
		},

		GetCharacterUpper()
		{
			return this.chance.character({pool:'ABCDEFGHIJKLMNOPQRSTUVWXYZ'});
		},

		GetCurrentDiceSum()
		{
			return this._lastDiceSum;
		},

		GetCurrentDiceAt(index)
		{
			if(index < 0 || index > this._lastDiceRoll.length-1){
				return -1;
			}

			return this._lastDiceRoll[index];
		},

		GetDiceSum(tag)
		{
			return this._diceRoll[tag].sum;
		},

		GetDiceAt(index, tag)
		{
			if(index < 0 || index > this._diceRoll[tag].roll.length-1){
				return -1;
			}

			return this._diceRoll[tag].roll[index];
		},

		GetStringUpper(length)
		{
			return this.chance.string({ length: length, pool: 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'});
		},

		GetStringLower(length)
		{
			return this.chance.string({ length: length, pool: 'abcdefghijklmnopqrstuvwxyz'});
		},

		GetStringPool(length, pool)
		{
			return this.chance.string({ length: length, pool: pool});
		},

		GetSyllable()
		{
			return this.chance.syllable();
		},

		GetWord(syllable)
		{
			return this.chance.word({ syllables: syllable });
		},

		GetSentence(words)
		{
			return this.chance.sentence({ words: words });
		},

		GetStandardDistribution(mean, dev)
		{
			return this.chance.normal({mean: mean, dev: dev});
		},

		GetInt(min, max)
		{
			return this.chance.integer({ min: min, max: max })
		},
		
		GetFloat()
		{
			return this.chance.floating();
		},
		GetFloatRange(min, max)
		{
			return this.chance.floating({ min: min, max: max })
		},
		GetFloatFixed(fixed)
		{
			return this.chance.floating({ fixed: fixed });
		},
		GetFloatRangeFixed(min, max, fixed)
		{
			return this.chance.floating({ min: min, max: max, fixed: fixed })
		},
		GetProfession()
		{
			return this.chance.profession();
		},
		GetProfessionRanked()
		{
			return this.chance.profession({rank: true});
		},
		GetMaleFullName()
		{
			return this.chance.name({
				middle: this.chance.bool(), 
				prefix: this.chance.bool(), 
				gender: 'male',
				nationality: 'en'
			});
		},
		GetFemaleFullName()
		{
			return this.chance.name({
				middle: this.chance.bool(), 
				prefix: this.chance.bool(), 
				gender: 'female',
				nationality: 'en'
			});
		},
		GetFemaleFirstName()
		{
			return this.chance.first({ nationality: 'us', gender: 'female' })
		},
		GetMaleFirstName()
		{
			return this.chance.first({ nationality: 'us', gender: 'male' })
		},
		GetLastName()
		{
			return this.chance.last({ nationality: 'us' });
		},
		Choose(values)
		{
			var list = values.split(',');
			return this.chance.pickone(list);
		},
		GetHash(length)
		{
			return this.chance.hash({length:length});
		},
		GetGuid()
		{
			return this.chance.guid();
		},
		GetCity()
		{
			return this.chance.city();
		},
		GetCountry()
		{
			return this.chance.country({full: true});
		},
		GetState()
		{
			return this.chance.state({full: true, country: 'us'});
		},
		GetLatitude()
		{
			return this.chance.latitude();
		},
		GetLongitude()
		{
			return this.chance.longitude();
		},
		GetWeighted(values, weights)
		{
			var a = values.split(',');
			var w = weights.split(',').map(Number);
			return this.chance.weighted(a, w);
		}

	};
}